'''
Priestesses of the Moon WCS:Python Race Coded By: J3ff Hoogland
'''
import wcs, es, random, gamethread, playerlib
from wcs import wcs
#Our Race's Name - This is not needed I just feel it makes things look cleaner
RaceName = 'Priestess of the Moon'
wcs.Race(RaceName).registerSkill('Trueshot Aura',3,2,'Yourself and all nearby allies have increased damage.')
wcs.Race(RaceName).registerSkill('Searing Arrows',3,2,'You hits deal extra damage and set fire to the target in exchange for some cash.')
wcs.Race(RaceName).registerSkill('Moon Glaive',5,1,'You attacks jump from target to target, each jump lessens the damage.')
wcs.Race(RaceName).registerUltimate('StarFall',6,3,4,'Hold your ultimate to deal damage to all near by oppents.')
wcs.Race(RaceName).registerMinLevel(50)
wcs.Race(RaceName).registerWeaponRestriction('block only', ('m3','xm1014'))
def player_spawn(event_var):
	userid = int(event_var['userid'])
	wcs.Command(userid).UpdateDict('trueshot list', [])
	auralevel = wcs.GetLevel(userid,RaceName,'Trueshot Aura')
	if auralevel:
		wcs.Command(userid).UpdateDict('true shot bonus', auralevel*.1)
		if not wcs.Command(userid).ReturnDict('looping'):
			aura_loop(userid)
def aura_loop(userid):
	if es.exists('userid', userid):
		if not playerlib.getPlayer(userid).get('isdead'):
			wcs.Command(userid).UpdateDict('looping',1)
			global truelist
			truelist = wcs.Command(userid).ReturnDict('trueshot list')
			for user in truelist:
				wcs.Command(user).Updatedict('true shot bonus', 0)
			truelist = []
			team = int(es.getplayerteam(userid))
			if team == 2:
				filter = '#t'
			elif team == 3:
				filter = '#ct'
			wcs.Command(userid).Near(240,auraset,filter)
			wcs.Command(userid).UpdateDict('trueshot list', truelist)
		else:
			wcs.Command(userid).UpdateDict('looping',0)
def auraset(userid, auramaster):
	global truelist
	truelist.append(userid)
	wcs.Command(userid).UpdateDict('true shot bonus', wcs.GetLevel(auramaster,RaceName,'Trueshot Aura')*.1)
	auraeffect(userid)
	gamethread.delayed(.45,auraeffect,userid)
	gamethread.delayed(.90,auraeffect,userid)
	gamethread.delayed(1.35,auraeffect,userid)
def auraeffect(userid):
	wcs.Effect().Ring1(userid,40,.5,255,255,255)
def player_hurt(event_var):
	userid = int(event_var['userid'])
	userPlayer = playerlib.getPlayer(userid)
	attacker = int(event_var['attacker'])
	if attacker:
		attackerPlayer = playerlib.getPlayer(attacker)
		damage = int(event_var['dmg_health'])
		glaive = wcs.GetLevel(attacker, RaceName, 'Moon Glaive')
		if glaive:
			team = int(es.getplayerteam(attacker))
			if team == 2:
				filter = '#ct'
			elif team == 3:
				filter = '#t'
			x,y,z = es.getplayerlocation(userid)
			plist = wcs.Command(userid).GetNearCoordList(x,y,z,120,120,120,filter)
			if plist:
				choice = random.choice(plist)
				wcs.Command(choice).Damage(damage/2,32,attacker)
				wcs.Effect().Beam2(userid,choice,1.5,128,42,42)
		searing = wcs.GetLevel(attacker, RaceName, 'Searing Arrows')
		if searing:
			cash = attackerPlayer.get('cash')
			if cash >= (searing*10):
				attackerPlayer.set('cash', cash-searing*10)
				wcs.Command(userid).Burn(1)
				wcs.Command(userid).Damage(searing*3,32,attacker)
		attackerkey = wcs.Command(attacker).ReturnUserKey()
		if attackerkey.has_key('true shot bonus'):
			wcs.Command(userid).Damage(damage*attackerkey['true shot bonus'],32,attacker)
def player_ultimate_on(event_var):
	userid = int(event_var['userid'])
	starfall = wcs.GetLevel(userid,RaceName,'StarFall')
	if starfall:
		wcs.Command(userid).UpdateDict('star falling',1)
		es.server.queuecmd('est_freeze %s 1'%userid)
		gamethread.delayed(starfall*15,ultiOff,userid)
		star_loop(userid)
def star_loop(userid):
	if wcs.Command(userid).ReturnDict('star falling'):
		wcs.Effect().Ring2(userid,50,1.6,191,62,255)
		wcs.Effect().Misc1(userid, 1.6)
		gamethread.delayed(1.5,star_loop,userid)
		team = int(es.getplayerteam(attacker))
		if team == 2:
			filter = '#ct'
		elif team == 3:
			filter = '#t'
		else:
			filer = '#all'
		wcs.Command(userid).Near(800,star_target,filter)
def star_target(userid, attacker):
	if not wcs.Command(userid).GetWallBetween(attacker):
		wcs.Command(userid).Damage(50,32,attacker)
		x,y,z = es.getplayerlocation(player1)
		es.server.queuecmd('est_effect 3 #a 0 sprites/lgtning.vmt %s %s %s %s %s %s %s 40 10 %s %s %s 255'%(x,y,z+300,x,y,z+30,2,191,62,255))
def player_ultimate_off(event_var):
	userid = int(event_var['userid'])
	if not wcs.Command(userid).GetCoolDown('StarFall'):
		ultiOff(userid)
def ultiOff(userid):
	if wcs.Command(userid).ReturnDict('star falling'):
		wcs.Command(userid).UpdateDict('star falling', 0)
		es.server.queuecmd('est_freeze %s 0'%userid)